/* src/vm/jit/arm/disass.c - wrapper functions for GNU binutils disassembler

   Copyright (C) 1996-2005 R. Grafl, A. Krall, C. Kruegel, C. Oates,
   R. Obermaisser, M. Platter, M. Probst, S. Ring, E. Steiner,
   C. Thalinger, D. Thuernbeck, P. Tomsich, C. Ullrich, J. Wenninger,
   Institut f. Computersprachen - TU Wien

   This file is part of CACAO.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   This program is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.

   Contact: cacao@complang.tuwien.ac.at

   Authors: Michael Starzinger

   $Id: disass.c,v 1.1 2005/06/09 10:26:00 michi Exp $

*/


#include "vm/jit/arm/disass.h"


char *regs[] = {
	"r0",
	"r1",
	"r2",
	"r3",
	"r4",
	"r5",
	"r6",
	"r7",
	"r8",
	"r9",
	"r10",
	"r11",
	"r12",
	"r13",
	"r14",
	"pc",
};


/* function disassinstr ********************************************************

   outputs a disassembler listing of one machine code instruction on 'stdout'
   code: instructions machine code

*******************************************************************************/

void disassinstr(s4 *code)
{
	//s4 c = *code;

	printf("0x%08x:   %08x    ", (s4) code, *code);

	// TODO: insert gdb disassembler here!
}


/* function disassemble ********************************************************

   outputs a disassembler listing of some machine code on 'stdout'
   code: pointer to first instruction
   len:  code size (number of instructions * 4)

*******************************************************************************/

void disassemble(s4 *code, int len)
{
	int i;

	printf ("  --- disassembler listing ---\n");
	for (i = 0; i < len; i += 4, code++)
		disassinstr(code);
}


/*
 * These are local overrides for various environment variables in Emacs.
 * Please do not remove this and leave it at the end of the file, where
 * Emacs will automagically detect them.
 * ---------------------------------------------------------------------
 * Local variables:
 * mode: c
 * indent-tabs-mode: t
 * c-basic-offset: 4
 * tab-width: 4
 * End:
 */
